<?php

/*

  Plugin Name: tbk Creative's Social Float

  Plugin URI: http://seocampaign.org/word-press-plugins/updated-social-float-plugin/

  Description: Show your facebook share button on a floating menu. Also includes, twitter, digg and google buzz.

  Version:0.2

  Author: Paul MacLean

  Author URI: http://seocampaign.org

  License: GPL2

 */

/*  Copyright 2010  Paul MacLean  (email : paul@tbkcreative.com)

  This program is free software; you can redistribute it and/or modify

  it under the terms of the GNU General Public License, version 2, as

  published by the Free Software Foundation.

  This program is distributed in the hope that it will be useful,

  but WITHOUT ANY WARRANTY; without even the implied warranty of

  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the

  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License

  along with this program; if not, write to the Free Software

  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 */

//Add hooks, actions and filters

register_activation_hook(__FILE__, 'social_floater_init');

register_deactivation_hook(__FILE__, 'social_floater_uninit');

$options = get_option('plugin_tbkfb_settings');

//This checkd for the auto loop option

if ($options['ffb_filt'] =="filt") {

  add_filter('loop_start', 'float_btns');

}

//Set Options

function social_floater_init() {

$ffb_options = array(

'ffb_align' => 'left',

 'ffb_facebook' => 'facebook',

 'ffb_buzz' => 'buzz',

 'ffb_twitter' => 'twitter',

 'ffb_digg' => 'digg',

 'ffb_filt' => 'filt',

 'ffb_custom' => '',

 'ffb_condition' => 'is_single()'

);

add_option('plugin_tbkfb_settings', $ffb_options);

}

//Delete Options

function social_floater_uninit() {

delete_option('plugin_tbkfb_settings');

}

//Helper function for conditional tag parsing

function get_string_between($string, $start, $end){

	$string = " ".$string;

	$ini = strpos($string,$start);

	if ($ini == 0) return "";

	$ini += strlen($start);

	$len = strpos($string,$end,$ini) - $ini;

	return substr($string,$ini,$len);

}

//Float Function - the function call asks for this

function float_btns() {

$blog_path_left = WP_PLUGIN_URL . '/' . str_replace(basename(__FILE__), "", plugin_basename(__FILE__)) . "share_arrow_left_side.png";

$blog_path_right = WP_PLUGIN_URL . '/' . str_replace(basename(__FILE__), "", plugin_basename(__FILE__)) . "share_arrow_right_side.png";

$options = get_option('plugin_tbkfb_settings');

$condition = $options['ffb_condition'];

$conditions = explode("||", $condition);

$ok = false;

$parameter ='';

foreach($conditions as $cond) {

  $cond = stripslashes($cond);

  //$pos = strpos($cond, "('");

      $parameter = get_string_between($cond, "(", ")");

      $parameter = stripslashes($parameter);

      $function_call = str_replace("($parameter)","",$cond);

        $parameter = get_string_between($parameter, "'", "'");

	//echo "   ".$parameter;

  $isnot = substr($cond, 0, 1);

     if ($isnot != "!") {

	$parameter="$parameter" ;

       if (@call_user_func($function_call,$parameter)){

         $ok = true;

       }

    }

}

if ($ok == true) {

//Set Floting Div Alignment

if ($options['ffb_align'] == 'right') {

echo '<div id ="right-side-wrap">

          <div id="right-side-container">

          <div id="sticky-anchor"></div>

          <div id="sticky"><img class ="right-side-arrow" src ="', $blog_path_right, '" alt="floating facebook button arrow right side"/>';

} else {

echo '<div id ="left-side-wrap"><div id ="left-side-arrow"></div>

            <div id="left-side-container">

              <div id="sticky-anchor"></div>

              <div id="sticky"><img class ="left-side-arrow" src ="', $blog_path_left, '" alt="floating facebook button arrow left side" />';

}

echo'<div class ="bring_up">';

//Put in social media buttons

 echo '<div class ="sm_button"><a href="http://twitter.com/share" class="twitter-share-button" data-count="vertical">Tweet</a><script type="text/javascript" src="http://platform.twitter.com/widgets.js"></script></div>';

if ($options['ffb_facebook'] == "facebook") {

echo '<div class = "sm_button"><a name="fb_share" type="box_count" href="http://www.facebook.com/sharer.php">Share</a><script src="http://static.ak.fbcdn.net/connect.php/js/FB.Share" type="text/javascript"></script></div><br/>';

}

if ($options['ffb_buzz'] == "buzz") {

echo '

              <div class = "sm_button"><a title="Post on Google Buzz" class="google-buzz-button" href="http://www.google.com/buzz/post" data-button-style="normal-count"></a></div>

              <script type="text/javascript" src="http://www.google.com/buzz/api/button.js"></script>';

}

if ($options['ffb_digg'] == "digg") {

echo '

              <script type="text/javascript">

	      (function() {

                var s = document.createElement("SCRIPT"), s1 = document.getElementsByTagName("SCRIPT")[0];

                s.type = "text/javascript";

                s.async = true;

                s.src = "http://widgets.digg.com/buttons.js";

                s1.parentNode.insertBefore(s, s1);

                })();

              </script>

              <div class = "sm_button"><a class="DiggThisButton DiggMedium"></a></div>';

}

if ($options['ffb_custom'] != '') {

echo stripslashes($options['ffb_custom']);

}

echo'</div>

        </div>

      </div>

    </div>

<!-- Floating Div Styles -->

<div>

<style type="text/css">

#left-side-wrap{

  position:relative;left:-5px;

  }

#left-side-container{

  position:absolute;

   background-color: #fff;

  -moz-border-radius: 0 0 0.5em 0.5em;

  -webkit-border-radius: 0 0 0.5em 0.5em;

   border-radius: 0 0 0.5em 0.5em;

   color: #000;

   font-size: 10px;

   border:1px solid; left:-85px;

   border-color:#B8B8B8;

}

.left-side-arrow{

 position:relative;left:70px;margin-right:-15px;

}

#right-side-wrap{

  float:right;

}

#right-side-container{

  position:absolute;margin-left:5px;background-color: #fff;

  -moz-border-radius: 0 0 0.5em 0.5em;

  -webkit-border-radius: 0 0 0.5em 0.5em;

  border-radius: 0 0 0.5em 0.5em;

}

.right-side-arrow{

 position:relative;left:-19px;

}

#tm_box {

     height:50px;

     width:50px;

}

#sticky {

  background-color: #fff;

  -moz-border-radius: 0 0 0.5em 0.5em;

  -webkit-border-radius: 0 0 0.5em 0.5em;

  border-radius: 0 0 0.5em 0.5em;

  color: #000;

  font-size: 10px;

  padding: 0.5ex;

  width:70px;

  }

#sticky.stick {

  border:1px solid;

  border-color:#B8B8B8;

  position: fixed;

  padding: 0.5ex;

  font-size: 10px;

  top: 0;

  z-index: 10000;

  margin-left:-1px;

  }

.bring_up{

 margin-top:-30px;

}

.sm_button{

 margin-right:auto;margin-left:auto;width:90px;z-index:1000;

 margin-bottom:10px;

 margin-left:5px;

}

</style>

</div>

<!-- Sticky Script to ensure div stays on top -->

<script src="http://www.google.com/jsapi" type="text/javascript"></script>

<script type="text/javascript">

google.load("jquery", "1");

function sticky_relocate() {

  var window_top = $(window).scrollTop();

  var div_top = $("#sticky-anchor").offset().top;

  if (window_top > div_top)

    $("#sticky").addClass("stick")

  else

    $("#sticky").removeClass("stick");

  }

  google.setOnLoadCallback(function() {

  $(window).scroll(sticky_relocate);

  sticky_relocate();

  });

</script>';

  }

}

//Get the option form

function admin_options() {

if ($_REQUEST['submit']) {

update_options();

}

print_option_form();

}

//Add the link on the settings menu

function modify_menu() {

add_options_page('Floating Social Media Buttons', 'Floating Social Media Buttons', 'manage_options', 'floating-share-buttons', 'admin_options');

}

add_action('admin_menu', 'modify_menu');

//Update changes to options

function update_options() {

$ok = false;

$options = get_option('plugin_tbkfb_settings');

$options['ffb_align'] = $_REQUEST['ffb_align'];

$options['ffb_facebook'] = $_REQUEST['ffb_facebook'];

$options['ffb_twitter'] = $_REQUEST['ffb_twitter'];

$options['ffb_buzz'] = $_REQUEST['ffb_buzz'];

$options['ffb_digg'] = $_REQUEST['ffb_digg'];

$options['ffb_custom'] = $_REQUEST['ffb_custom'];

$options['ffb_filt'] = $_REQUEST['ffb_filt'];

$options['ffb_condition'] = $_REQUEST['ffb_condition'];

update_option('plugin_tbkfb_settings', $options);

$ok = true;

if ($ok) {

?>

<div id ="message" class ="updated fade">

    <p>Floating Facebook Options have been saved</p>

</div>

<?php

} else {

?>

<div id ="message" class="error fade">

    <p>There was trouble saving the settings..if the problem persists please contact paul@tbkcreative.com</p>

</div>

<?php

}

}

//HTML form for options

function print_option_form() {

$options = get_option('plugin_tbkfb_settings');

?>

<div class="wrap">

    <div style ="float:right"><a href ="http://www.tbkcreative.com/the-lab/wordpress-social-media-buttons" target ="_blank"><img alt="tbk creative"  src ="http://www.tbkcreative.com/wp-content/themes/splatter/images/logo.jpg"></a></div><div style="clear:both"></div>

    <div id="icon-options-general" class="icon32"><br />

    </div>

    <h2>Floating Social Media Button Settings</h2>

    <br/><br/><br/>

    <form  method="post">

	<div style="float:left;height:30px;margin-right:30px;">Floating Div Alignment</div>

	<input type="radio" name="ffb_align" value="right" <?php if ($options['ffb_align'] == 'right'

)echo'checked'; ?>>

	Right Side of Blog<br/>

	<input type="radio" name="ffb_align" value="left" <?php if ($options['ffb_align'] == 'left'

	       )echo'checked'; ?>>

	Left Side of Blog<br/>

	<br/>

	<div style="float:left;height:70px;margin-right:35px;">Social Media Buttons</div>

	<input type="checkbox" name="ffb_twitter" value="twitter" <?php if ($options['ffb_twitter'] == 'twitter'

	       )echo'checked=yes'; ?>>

        Twitter Retweet Button<br/>

        <input type="checkbox" name="ffb_facebook" value="facebook"

	<?php if ($options['ffb_facebook'] == 'facebook'

	       )echo'checked=yes'; ?>>

        Facebook Share Button<br/>

        <input type="checkbox" name="ffb_buzz" value="buzz"

	<?php if ($options['ffb_buzz'] == 'buzz'

	       )echo'checked=yes'; ?>>

        Google Buzz Button<br/>

        <input type="checkbox" name="ffb_digg" value="digg"

	<?php if ($options['ffb_digg'] == 'digg'

	       )echo'checked=yes'; ?>>

        Digg Button<br/><br/>

	<div style="float:left;height:70px;margin-right:35px;">Conditional Tag</div>

	<input style ="margin-left:36px;width:600px;" type="text" name="ffb_condition" value="<?php echo  stripslashes($options['ffb_condition']); ?>"/>

	<br/> <div style ="width:700px;position:relative;left:40px;top:10px">Use Conditional Tags here display the Social Float bar on specific pages or posts, separated by the || operator. (ex is_home()||is_page('about'). For a full list of conditional tags please visit <a href ="http://codex.wordpress.org/Conditional_Tags" target="_blank">http://codex.wordpress.org/Conditional_Tags</a></div>

	<br/> <br/> <br/> <br/> <br/>

        <div style="float:left;margin-right:55px;">Custom Code</div>

        <textarea rows="10" cols="100" name="ffb_custom"><?php echo stripslashes($options['ffb_custom'])

	       ; ?></textarea> <br/> <br/>

   	<div style="float:left;height:30px;margin-right:30px;">Function Call(for developers): </div> &#60;&#63;&#112;&#104;&#112;&#32;&#105;&#102;&#40;&#102;&#117;&#110;&#99;&#116;&#105;&#111;&#110;&#95;&#101;&#120;&#105;&#115;&#116;&#115;&#40;&#39;&#102;&#108;&#111;&#97;&#116;&#95;&#98;&#116;&#110;&#115;&#39;&#41;&#41;&#123;&#102;&#108;&#111;&#97;&#116;&#95;&#98;&#116;&#110;&#115;&#40;&#41;&#59;&#32;&#125;&#32;&#63;&#62;

   	&nbsp;&nbsp;&nbsp;&nbsp; Auto Filter On:<input type="checkbox" name="ffb_filt" value="filt"

	<?php if ($options['ffb_filt'] == 'filt'

	       )echo'checked=yes'; ?>>

        <br/> <br/>

        <input type="submit" name ="submit" value ="Submit" />

    </form>

</div>

<?php

  }

//add help link to footer

add_action( 'in_admin_footer', 'ffb_admin_footer' );

function ffb_admin_footer() {

	$plugin_data = get_plugin_data( __FILE__ );

	printf('%1$s plugin | Version %2$s<br />', $plugin_data['Title'], $plugin_data['Version']);

}

?>